<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Adminhtml\Report;


class Details extends \Magento\Backend\Block\Widget\Form\Container
{
    /**
     * @var string
     */
    protected $_template = 'report/form.phtml';

    /**
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context,
        array $data = []
    ) {
        
        parent::__construct($context, $data);
    }
    
    public function _construct()
  {
   
        $message = __('Connecting to Lay-Buy server to fetch transaction updates. Are you sure you want to proceed?');
        $this->addButton('fetch', [
            'label'   => __('Fetch Updates'),
            'onclick' => "confirmSetLocation('{$message}', '{$this->getUrl('*/*/fetch',array('_secure' => true))}')",
            'class'   => 'primary'
        ]);
        
        
        
        parent::__construct();

		$message = __("Are you sure to cancel this transaction? Because it will cancel the buyer order and recurring profile");
		$model = $this->_coreRegistry->registry('current_laybuy_transaction');
		if($model->getStatus() == 0){
			$this->addButton('delete', array(

				'label'   => __('Cancel Transaction'),

				'onclick' => "confirmSetLocation('{$message}', '{$this->getUrl('*/*/cancel',array('_secure' => true,'id'=>$this->getRequest()->getParam('id')))}')",

				'class'	  => 'delete',
			));
		}
		if(in_array($model->getStatus(),array(-2))) {
			$this->addButton('resend', array(
		
				'label'    => __('Resend Email to Buyer'),
				
				'onclick'  => "setLocation('{$this->getUrl('*/*/edit',array('_secure' => true,'id'=>$this->getRequest()->getParam('id')))}')",
				
				'class'	   => 'add',
			));
			$this->addButton('edit', array(
			
					'label'    => __('Revise Instalment Plan'),
					
					'onclick'  => "setLocation('{$this->getUrl('*/*/edit',array('_secure' => true,'id'=>$this->getRequest()->getParam('id'),'reviseagain'=>1))}')",
					
					'class'	   => 'add',
				));
		}
		if(in_array($model->getStatus(),array(0))) {
			if(strlen($model->getReviseConfirmMessage())>0) {
				$this->addButton('edit', array(
				
						'label'    => __('Revise Instalment Plan'),
						
						'onclick'  => "confirmSetLocation('{$model->getReviseConfirmMessage()}', '{$this->getUrl('*/*/edit',array('_secure' => true,'id'=>$this->getRequest()->getParam('id')))}')",
						
						'class'	   => 'add',
					));
			} else {
				$this->_addButton('edit', array(
				
						'label'    => __('Revise Instalment Plan'),
						
						'onclick'  => "setLocation('{$this->getUrl('*/*/edit',array('_secure' => true,'id'=>$this->getRequest()->getParam('id')))}')",
						
						'class'	   => 'add',
					));
			}
			
		}
        
  }

    /**
     * Prepare button and grid
     * @return $this
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareLayout()
    {
        $this->setChild(
            'form',
            $this->getLayout()->createBlock('Ced\LayBuy\Block\Adminhtml\Report\Details\Form', 'ced.laybuy.report.form')
        );
        return parent::_prepareLayout();
    }

   

    /**
     * Render grid
     *
     * @return string
     */
    public function getFormHtml()
    {
        return $this->getChildHtml('form');
    }
}
