<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Adminhtml;


class Docalc extends \Magento\Backend\Block\Template {

    
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Stdlib\DateTime $datedata,
        \Magento\Framework\Locale\CurrencyInterface $localeCurrency
    )
    {
        $this->date = $datedata;
        $this->currency = $localeCurrency;
        parent::__construct($context);
    }

    /**
     *
     */
    protected function _toHtml()
    {
        $header = '<html>';
		$header .= '<head>';
		$header .= '</head>';
		$header .= '<body style="font: 12px/1.5em; background: none repeat scroll 0 0 rgba(0, 0, 0, 0);">';
		$header .= '<div class="grid" style="padding: 5px 0px;background-color: #f5f5f5;">';
		$header .= '<div class="hor-scroll">';
		$html = '<table cellspacing="0" class="data" width="100%">';
		$html .= '<colgroup>
				<col width="175">
				<col width="183">
				<col width="98">
			  </colgroup>';
		 	
		 $tod=time();
		 
		 $isLeap = 0;
		 $isLeap = Date('L',$tod);
		 if($isLeap)
			$dim=array(31,31,29,31,30,31,30,31,31,30,31,30,31);
		 else
			$dim=array(31,31,28,31,30,31,30,31,31,30,31,30,31);
		 
		 $day=Date('d',$tod);
		 $mth=Date('m',$tod);
		 $yr=Date('Y',$tod);
		 $mnth=$this->getRequest()->getParam('mnth');
		 $hght=150 / (2 + $mnth);
		 $html .= '<thead><tr class="headings"><th class=" no-link" style="text-align: center; font-size: 16px; padding-bottom: 5px; padding-top: 5px;"><span class="nobr">Payment</span></th><th class=" no-link" style="text-align: center; font-size: 16px; padding-bottom: 4px; padding-top: 4px;"><span class="nobr">Due Date</span></th><th class=" no-link" style="text-align: center; font-size: 16px; padding-bottom: 4px; padding-top: 4px;"><span class="nobr">Amount</span></th></tr></thead>';
		 $init=$this->getRequest()->getParam('init');
		 $amt=$this->getRequest()->getParam('amt');
		 $currency = $this->getRequest()->getParam('currency');
		 $dep=$amt*$init/100;
		 $rest=number_format(($amt-$dep)/$mnth,2,'.','');
		 $dep=number_format($amt - $rest * $mnth,2,'.','');
		 $html .= '<tbody><tr class="even" ><td style="text-align: center;">DownPayment</td><td style="text-align: center;">Today</td><td style="text-align:center">'.$this->currency->getCurrency($currency)->toCurrency($dep).'</td></tr>';
		 for ($e=1; $e<=$mnth; $e++) {
			if (++$mth>12) {
			  $mth='01';
			  $yr++;
			}
			$m=1+$mth-1;
			$d=min($day,$dim[$m]);
			$even = '';
			if($e%2==0)
				$even = ' class="even"';
			$date = '';
			$date = $d.'-'.$mth.'-'.$yr;
			$date = $this->formatDate($date, \IntlDateFormatter::MEDIUM, true);
			if($e==1){
				$first_payment_due = $date;
			}
			$html .= '<tr'.$even.' ><td style="text-align: center;padding: 5px 0px;">'.$e.'</td><td style="text-align: center;padding: 5px 0px;">'.$date.'</td><td style="text-align:center;padding: 5px 0px;">'.$this->currency->getCurrency($currency)->toCurrency($rest).'</td></tr>';
		 }
		$html .= '</tbody>';
		$html .= '</table>';
		$footer = '</div>';
		$footer .= '</div>';
		$footer .= '</body>';
		$footer .= '</html>';
		if($this->getRequest()->getParam('html')){
			return $header.$html.$footer;
		}else{
			return $dep.'~'.$rest.'~'.$first_payment_due.'~'.$date.'~'.$html;
		}
    }
}