<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Adminhtml\Report;


class Edit extends \Magento\Backend\Block\Widget\Form\Container
{
    /**
     * @var string
     */
    protected $_template = 'report/form.phtml';

    /**
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context,
        \Magento\Framework\Registry $registry,
        \Ced\LayBuy\Model\ResourceModel\Revise\CollectionFactory $collectionFactory,
        array $data = []
    ) {
        $this->registry = $registry;
        $this->collectionFactory = $collectionFactory;
        parent::__construct($context, $data);
    }
    
    public function _construct()
  {
   
        parent::_construct();
        $this->removeButton('save');
        $this->removeButton('back');
        $this->removeButton('reset');
        $this->removeButton('delete');
		$message = __('Are you sure to cancel this transaction?');
		$model = $this->registry->registry('current_laybuy_transaction_edit');
		$this->addButton('backbutton', array(
		
			'label'    => __('Back'),
			
			'onclick'  => "setLocation('{$this->getUrl('*/*/details',array('_secure' => true,'id'=>$this->getRequest()->getParam('id')))}')",
			
			'class'	   => 'back',
		));
		$buttonLabel = __('Save and Send Email to Buyer');
		if($model->getStatus() == -2) {
			$revised = $this->collectionFactory->create()
							->addFieldToFilter('transaction_id',array('eq'=>$model->getId()))
							->addFieldToFilter('type',array('eq'=>'new'))->getLastItem();
			if($revised && $revised->getId()){
				$model = $revised;
				if($this->getRequest()->getParam('reviseagain')) {
					
				} else {
					$buttonLabel = __('Resend Email to Buyer');
				}
			}
		}
		$this->addButton('save', array(
			
				'label'    => $buttonLabel,
				
				'onclick'  => "edit_form.submit()",
				
				'class'	   => 'save primary',
			));
        
  }

    /**
     * Prepare button and grid
     * @return $this
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareLayout()
    {
        $this->setChild(
            'form',
            $this->getLayout()->createBlock('Ced\LayBuy\Block\Adminhtml\Report\Edit\Form', 'ced.laybuy.edit')
        );
        return parent::_prepareLayout();
    }

   

    /**
     * Render grid
     *
     * @return string
     */
    public function getFormHtml()
    {
        return $this->getChildHtml('form');
    }
}
