<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Customer\Account;


class Details extends \Magento\Framework\View\Element\Template {

protected $_links = array();
	protected $_orderId = null;
   
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Framework\Stdlib\DateTime $datedata,
        \Magento\Framework\Locale\CurrencyInterface $localeCurrency,
        \Ced\LayBuy\Helper\Data $laybuyHelper,
        \Ced\LayBuy\Model\ReportFactory $report,
        \Magento\Sales\Model\OrderRepository $orderRepository
    )
    {
        $this->report = $report;
        $this->laybuyHelper = $laybuyHelper;
        $this->date = $datedata;
        $this->currency = $localeCurrency;
        $this->order  = $orderRepository;
        parent::__construct($context);
    }

    protected function _construct()
    {
        parent::_construct();
		$this->_orderId = $this->getRequest()->getParam('order_id');
		$order =  $this->order->get($this->_orderId);
		$orderIncrementId = $order->getIncrementId();
        $this->setOrderIncrementId($orderIncrementId);
		$this->setOrderStatusLabel($order->getStatusLabel());
		$transaction = $this->report->create()->load($this->getRequest()->getParam('id'));

        $this->setTransaction($transaction);

        
    }
	
	public function getTransactionStatusLabel($statusId){
		$statuses = $this->laybuyHelper->getStatuses();
		return $statuses[$statusId];
	}

	public function getBackUrl()
    {
        return $this->getUrl('laybuy/report/grid/',['_secure' => true,'order_id'=>$this->_orderId]);
    }
	
	public function getBackTitle()
    {
        return __('Back');
    }
    
    public function getLocaleCurrency(){
        return $this->currency;
    }
    
}