<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Customer\Account;


class Grid extends \Magento\Framework\View\Element\Template {

protected $_links = array();
	protected $_orderId = null;
  
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Framework\Stdlib\DateTime $datedata,
        \Magento\Framework\Locale\CurrencyInterface $localeCurrency,
        \Ced\LayBuy\Helper\Data $laybuyHelper,
        \Ced\LayBuy\Model\ReportFactory $report,
        \Magento\Sales\Model\OrderRepository $orderRepository
    )
    {
        $this->report = $report;
        $this->laybuyHelper = $laybuyHelper;
        $this->date = $datedata;
        $this->currency = $localeCurrency;
        $this->order  = $orderRepository;
        parent::__construct($context);
    }


	
    public function _construct()
    {
        parent::_construct();
		
		$this->_orderId = $this->getRequest()->getParam('order_id');
		$order =  $this->order->get($this->_orderId);
		$orderIncrementId = $order->getIncrementId();
        $this->setOrderIncrementId($orderIncrementId);
		$this->setOrderStatusLabel($order->getStatusLabel());
		$transactions = $this->report->create()->getCollection()->addFieldToFilter('order_id',['eq'=>$orderIncrementId]);

        $this->setTransactions($transactions);

    }

    protected function _prepareLayout()
    {
        parent::_prepareLayout();

        $pager = $this->getLayout()->createBlock('Magento\Theme\Block\Html\Pager', 'sales.order.transaction.pager')
            ->setCollection($this->getTransactions());
        $this->setChild('pager', $pager);
        $this->getTransactions()->load();
        return $this;
    }

    public function getPagerHtml()
    {
        return $this->getChildHtml('pager');
    }

    public function getViewUrl($transaction)
    {
        return $this->getUrl('*/*/details', ['_secure' => true,'order_id'=>$this->_orderId,'id' => $transaction->getId()]);
    }

    public function getBackUrl()
    {
        return $this->getUrl('sales/order/view/',['_secure' => true,'order_id'=>$this->_orderId]);
    }
	
	public function getBackTitle()
    {
        return __('Back to Order View');
    }
    
    public function getLocaleCurrency(){
        return $this->currency;
    }
    
}