<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Block\Form;

class Laybuy extends \Magento\Payment\Block\Form
{
    
    
    public function __construct(
            \Magento\Framework\View\Element\Template\Context $context,
            \Magento\Checkout\Model\Session $checkoutSession,
            \Ced\LayBuy\Model\Report $laybuyReport,
            \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
            \Magento\Store\Model\StoreManager $storeManager,
    		array $data = []
    	)
        {
            
            parent::__construct($context,$data);
            $this->checkoutSession = $checkoutSession;
            $this->laybuyReport = $laybuyReport;
            $this->storeManager = $storeManager;
            $this->scopeConfig = $scopeConfig;
        }
        
    protected function _construct()
    {
        parent::_construct();
		
		$laybuyMark = $this->getLayout()->createBlock('Magento\Framework\View\Element\Template');
        $laybuyMark->setTemplate('Ced_LayBuy::laybuy/form/laybuy.phtml')
			 ->setLayBuyTitle(__('A recurring payment solution'))
			 ->setPaymentAcceptanceMarkSrc('https://lay-buys.com/gateway/LAY-BUY.png')
			 ->setPaymentAcceptanceMarkHref('https://lay-buys.com/');
		$note = 'Please Choose Your Payment Plan';
		$this->setTemplate('Ced_LayBuy::laybuy/form/extra.phtml')
			 ->setMethodTitle('')
			 ->setExtraMessage('<b>'.__('%1',$note).'</b>')
			 ->setMethodLabelAfterHtml($laybuyMark->toHtml());
    }
	
	public function getArray($type){
		$totals = $this->checkoutSession->getQuote()->getTotals();
		$grandtotal = round($totals["grand_total"]->getValue());
		return $this->laybuyReport->getArray($type,$grandtotal,$this->getStoreId());
	}
	
	public function getConfigData($field){
		return $this->scopeConfig->getValue('payment/laybuy/'.$field,\Magento\Store\Model\ScopeInterface::SCOPE_STORE,$this->getStoreId());
	}
	
	public function getQuoteData(){
	    return $this->checkoutSession->getQuote();
	}
	public function getMethodCode(){
	    return 'laybuy';
	}
	
	public function getStore(){
	    return $this->storeManager->getStore();
	}
}
