<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Standard;


class DoCalc extends \Magento\Framework\View\Element\Template {

    
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\Stdlib\DateTime $datedata,
        \Magento\Framework\Locale\CurrencyInterface $localeCurrency,
        \Magento\Checkout\Model\Cart $cart
    )
    {
        $this->checkoutSession = $checkoutSession;
        $this->date = $datedata;
        $this->currency = $localeCurrency;
        $this->cart  = $cart;
        parent::__construct($context);
    }

    /**
     *
     */
    protected function _toHtml()
    {
        $header = '<html>';
		$header .= '<head>';
		$header .= '<style type="text/css">.grid table td{ font-size: 12px !important; }</style>';
		$header .= '</head>';
		$header .= '<body style="font: 12px/1.5em; background: none repeat scroll 0 0 rgba(0, 0, 0, 0);">';
		$header .= '<div class="grid">';
		$header .= '<div class="hor-scroll">';
		$html = '<table cellspacing="0" class="data" width="100%" height="100%">';
		$html .= '<colgroup>
				<col width="33%">
				<col width="33%">
				<col width="33%">
			  </colgroup>';
		 $tod=time();		 
		 $isLeap = 0;
		 $isLeap = Date('L',$tod);
		 if($isLeap)
			$dim=array(31,31,29,31,30,31,30,31,31,30,31,30,31);
		 else
			$dim=array(31,31,28,31,30,31,30,31,31,30,31,30,31);
		 /* print_r($dim);die; */
		  $day=Date('d',$tod);
		  $mth=Date('m',$tod);
		  $yr=Date('Y',$tod);
		  $laybuyInfo = $this->checkoutSession->getLaybuyInfo();
		  if($this->getRequest()->getParam('mnth')){
		      $mnth  = $this->getRequest()->getParam('mnth');
		  }else{
		      $mnth = $laybuyInfo['mnth'];
		  }
		 //$mnth=$this->getRequest()->getParam('mnth');
		 $hght=150 / (2 + $mnth);
		 $html .= '<thead><tr class="headings"><th class=" no-link" style="text-align: center; font-size: 14px; padding-bottom: 4px; padding-top: 4px;"><span class="nobr">Payment</span></th><th class=" no-link" style="text-align: center; font-size: 14px; padding-bottom: 4px; padding-top: 4px;"><span class="nobr">Due Date</span></th><th class=" no-link" style="text-align: center; font-size: 14px; padding-bottom: 10px; padding-top: 5px;"><span class="nobr">Amount</span></th></tr></thead>';
		 $init=$this->getRequest()->getParam('init');
		 if($this->getRequest()->getParam('amt')){
			
			$amt=$this->getRequest()->getParam('amt');
			
			$this->checkoutSession->setLaybuyInfo($this->getRequest()->getParams());
			
		 }else{
			$totals = $this->checkoutSession->getQuote()->getTotals();
		
			$amt = $totals["grand_total"]->getValue();
		 }

		 $currency = $this->getRequest()->getParam('currency');
		 $dep=$amt*$init/100;

		 $rest=number_format(($amt-$dep)/$mnth,2,'.','');
		 $dep=number_format($amt - $rest * $mnth,2,'.','');
		 $html .= '<tbody><tr class="even" ><td style="text-align: center;">DownPayment</td><td style="text-align: center;">Today</td><td style="text-align:center">'.$this->currency->getCurrency($currency)->toCurrency($dep).'</td></tr>';
		 for ($e=1; $e<=$mnth; $e++) {
			if (++$mth>12) {
			  $mth='01';
			  $yr++;
			}
			$m=1+$mth-1;
			$d=min($day,$dim[$m]);
			$even = '';
			if($e%2==0)
				$even = ' class="even"';
			$date = '';
			$date = $d.'-'.$mth.'-'.$yr;
			$date = $this->formatDate($date,\IntlDateFormatter::MEDIUM);
			if($e==1){
				$first_payment_due = $date;
			}
			$html .= '<tr'.$even.' ><td style="text-align: center;">'.$e.'</td><td style="text-align: center;">'.$date.'</td><td style="text-align:center">'.$this->currency->getCurrency($currency)->toCurrency($rest).'</td></tr>';
		 }
		$html .= '</tbody>';
		$html .= '</table>';
		$footer = '</div>';
		$footer .= '</div>';
		$footer .= '</body>';
		$footer .= '</html>';
		if($this->getRequest()->getParam('html')){
			return $header.$html.$footer;
		}else{
			return $dep.'~'.$rest.'~'.$first_payment_due.'~'.$date.'~'.$html;
		}
    }
}