<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Block\Standard;
use Ced\LayBuy\Helper;

class Redirect extends \Magento\Framework\View\Element\Template {

    
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Framework\Stdlib\DateTime $datedata,
        \Magento\Framework\Locale\CurrencyInterface $localeCurrency,
        Helper\Data $laybuyHelper,
        Helper\Config $laybuyConfig,
        \Magento\Framework\App\Response\Http $response,
        \Magento\Framework\Message\ManagerInterface $messageManager
    )
    {
        $this->checkoutSession = $checkoutSession;
        $this->date = $datedata;
        $this->currency = $localeCurrency;
        $this->laybuyHelper= $laybuyHelper;
        $this->laybuyConfig = $laybuyConfig;
        $this->response = $response;
        $this->messageManager = $messageManager;
        parent::__construct($context);
        
        $this->addData(array('cache_lifetime' => null));
    }

    /**
     *
     */
     protected function _construct()
    {
        parent::_construct();
        $this->addData(array('cache_lifetime' => null));
    }
    public function getCacheLifetime()
    {
        return null;
    }
    protected function _toHtml()
    {
        
		$redirectURL = $this->laybuyConfig->getSubmitUrl();
		//print_r($redirectURL);die;
		$session = $this->checkoutSession;
		$data =  $this->laybuyConfig->extractAndPrepareRequiredValueForFormFields($session);
		
		$html ='';
		if ($token = $this->laybuyHelper->postToLaybuy($redirectURL,$this->laybuyConfig->getStandardCheckoutFormFields($data))) {
			$session->setLayBuyToken($token);
			$redirectURL .= '?TOKEN='.$token;
			$html = '<html><body>';
			$html.= __('You will be redirected to the PayPal website in a few seconds.');
			$html.= '<br><input type="button" onClick="window.location=\''.$redirectURL.'\' " value="'.__('Click here if you are not redirected within 10 seconds...').'" />';
			$html.= '<script type="text/javascript">setTimeout(\'window.location="'.$redirectURL.'"\',1000);</script>';
			$html.= '</body></html>';
		}else{
			$this->messageManager->addErrorMessage(__('Order # - '.$data ["CUSTOM"].' successfull but payment not completed. Please inform store owner.'));
			$html = $this->response->setRedirect($this->getUrl('checkout/onepage/failure'));
		
		}
		return $html;
    }
}