<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Adminhtml\Report;

use Magento\Framework\Exception\CouldNotSaveException;


class Cancel extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
        protected $resultPageFactory;

    /**
     * Index constructor.
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
        public function __construct(
            \Magento\Backend\App\Action\Context $context,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Ced\LayBuy\Model\ReportFactory $laybuyReport,
            \Ced\LayBuy\Model\ResourceModel\Revise\CollectionFactory $reviseCollection,
            \Ced\LayBuy\Model\ReviseFactory $revise,
            \Ced\LayBuy\Helper\Data $laybuyHelper
        )
        {
            parent::__construct($context);
            $this->resultPageFactory = $resultPageFactory;
            $this->laybuyReport = $laybuyReport;
            $this->reviseCollection = $reviseCollection;
            $this->revise = $revise;
            $this->helper = $laybuyHelper;
        }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        
       $id = $this->getRequest()->getParam('id');
		$model = $this->laybuyReport->create()->load($id);
	
		try{
			/* $model->setReport($newStr)->setStatus(-1)->save(); */
			if($this->helper->cancelTransaction($model)){
				$this->messageManager->addSuccessMessage(
					__("Transaction was cancelled successfully.")
				);
			}else{
				$this->messageManager->addErrorMessage(
					'Cancel request was unsuccessful.Please try again!!'
				);
			}
		}catch (\Exception $e) {
			$this->messageManager->addErrorMessage(
				$e->getMessage()
			);
			
		}
		return $this->_redirect('*/*/details',['_secure' => true,'id'=>$id]);
    }
}