<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Adminhtml\Report;

use Magento\Framework\Exception\CouldNotSaveException;


class Details extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
        protected $resultPageFactory;

    /**
     * Index constructor.
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
        public function __construct(
            \Magento\Backend\App\Action\Context $context,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Ced\LayBuy\Model\ReportFactory $laybuyReport,
            \Ced\LayBuy\Model\ResourceModel\Revise\CollectionFactory $reviseCollection,
            \Ced\LayBuy\Model\ReviseFactory $revise,
            \Ced\LayBuy\Helper\Data $laybuyHelper,
            \Magento\Framework\Registry $registry
        )
        {
            parent::__construct($context);
            $this->resultPageFactory = $resultPageFactory;
            $this->laybuyReport = $laybuyReport;
            $this->reviseCollection = $reviseCollection;
            $this->revise = $revise;
            $this->helper = $laybuyHelper;
            $this->registry = $registry;
        }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        
      $rowId = $this->getRequest()->getParam('id');
		$fbr = $this->getRequest()->getParam('fbr',0);
        $row = $this->laybuyReport->create()->load($rowId);
        if (!$row->getId()) {
            $this->_redirect('*/*/',['_secure' => true]);
            return;
        }
		$row->setReviseConfirmMessage('');
		if($fbr && $this->helper->fetchBeforeRevise($row->getData('paypal_profile_id'))) {
			$row = $this->laybuyReport->create()->load($row->getId());
		} elseif($fbr) {
			$row->setReviseConfirmMessage(__("Are you sure to Revise Instalment Plan because instalment reports are not up-to-date."));
		}
		$this->registry->register('current_laybuy_transaction', $row);

			
			$resultPage = $this->resultPageFactory->create();
      
        $resultPage->getConfig()->getTitle()->prepend(__('View Transaction'));
        return $resultPage;
       
       
    }
}