<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Adminhtml\Report;

use Magento\Framework\Exception\CouldNotSaveException;


class Fetch extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
        protected $resultPageFactory;

    /**
     * Index constructor.
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
        public function __construct(
            \Magento\Backend\App\Action\Context $context,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Ced\LayBuy\Model\Report $laybuyReport
        )
        {
            parent::__construct($context);
            $this->resultPageFactory = $resultPageFactory;
            $this->laybuyReport = $laybuyReport;
        }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        
        try {

            $credentials = $this->laybuyReport->getApiCredentials();
            if (empty($credentials)) {
                
                throw new CouldNotSaveException (__('Nothing to fetch because of an empty configuration.'));
            }
            foreach ($credentials as $config) {
                try {
                    $fetched = $this->laybuyReport->fetchAndSave($config);
					if($fetched){
						$this->messageManager->addSuccessMessage(
							__("Fetched %1 report rows from '%1'.", $fetched, $config['hostname'])
						);
					}else{
						$this->messageManager->addSuccessMessage(
							__("There is no new Transaction.")
						);
					}
                } catch (\Exception $e) {
                    $this->messageManager->addErrorMessage(
                        __("Failed to fetch reports from '%1'.%2", $config['hostname'],$e->getMessage())
                    );
                }
            }
        } catch (\Exception $e) {
            $this->messageManager->addErrorMessage($e->getMessage());
        } catch (\Exception $e) {
            $this->messageManager->addErrorMessage($e->getMessage());
        }
        return $this->_redirect('*/*/index',['_secure' => true]);
       
       
    }
}