<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Adminhtml\Report;

use Magento\Framework\Exception\CouldNotSaveException;

/**
 * Class Index
 * @package Ced\CreditLimit\Controller\Adminhtml\Climit
 */
class Resend extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
        protected $resultPageFactory;

    /**
     * Index constructor.
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
        public function __construct(
            \Magento\Backend\App\Action\Context $context,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Ced\LayBuy\Model\ReportFactory $laybuyReport,
            \Ced\LayBuy\Model\ResourceModel\Revise\CollectionFactory $reviseCollection,
            \Ced\LayBuy\Model\ReviseFactory $revise,
            \Ced\LayBuy\Helper\Data $laybuyHelper
        )
        {
            parent::__construct($context);
            $this->resultPageFactory = $resultPageFactory;
            $this->laybuyReport = $laybuyReport;
            $this->reviseCollection = $reviseCollection;
            $this->revise = $revise;
            $this->helper = $laybuyHelper;
        }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        
      $revise = $this->revise->create()->load($this->getRequest()->getParam('is_revised',0));
		$rowId = $this->getRequest()->getParam('id');
		if($revise && $revise->getId()) {
			try {
				if($this->helper->revisePlan($revise)){

					$this->messageManager->addSuccessMessage(
						__("Email re-sent to %1 for order#%2",$revise->getEmail(),$revise->getOrderId())
					);
				} else {
					$this->messageManager->addErrorMessage(
						__("Failed to re-send email")
					);
				}
			} catch (Exception $e) {
				$this->messageManager->addErrorMessage(
						__($e->getMessage())
					);
			}
		}
		return $this->_redirect('*/*/details',['_secure' => true,'id'=>$rowId]);
       
       
    }
}