<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Adminhtml\Report;

use Magento\Framework\Exception\CouldNotSaveException;


class Save extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
        protected $resultPageFactory;

    /**
     * Index constructor.
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
        public function __construct(
            \Magento\Backend\App\Action\Context $context,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Ced\LayBuy\Model\ReportFactory $laybuyReport,
            \Ced\LayBuy\Model\ResourceModel\Revise\CollectionFactory $reviseCollection,
            \Ced\LayBuy\Model\ReviseFactory $revise,
            \Ced\LayBuy\Helper\Data $laybuyHelper
        )
        {
            parent::__construct($context);
            $this->resultPageFactory = $resultPageFactory;
            $this->laybuyReport = $laybuyReport;
            $this->reviseCollection = $reviseCollection;
            $this->revise = $revise;
            $this->helper = $laybuyHelper;
        }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page
     */
    public function execute()
    {
        
       if($this->getRequest()->getParam('is_revised')){
			$this->_forward('resend');
			return;
		}
        $rowId = $this->getRequest()->getParam('id');
        $data = $this->getRequest()->getParams();
		/* print_r($data);die; */
		$reportModel = $this->laybuyReport->create()->load($rowId);
		
		$temp = array();
		$temp['original']= $temp['new']= $reportModel->getData();
		$temp['original']['transaction_id'] = $temp['new']['transaction_id'] = $reportModel->getId();
		$temp['original']['type'] = 'original';
		$temp['new']['type'] = 'new';
		$temp['new']['amount'] = $data['amount'];
		$temp['new']['months'] = $data['months'];
		$temp['new']['first_payment_due'] = $data['first_payment_due'];
		$temp['new']['last_payment_due'] = $data['last_payment_due'];
		$temp['new']['months'] = $data['months'];
		$temp['new']['email'] = $data['email'];
		$temp['new']['downpayment'] = $data['dp_amount'];
		$temp['new']['downpayment_amount'] = $data['downpayment_amount'];
		$temp['new']['payment_amounts'] = $data['payment_amounts'];
		$temp['new']['created_at']	= date('Y-m-d h:i:s',time());
		$temp['new']['report'] = $data['report'];
		$temp['new']['payment_type'] = $data['pp'];/* if($data['pp']){ Lay-Buy Payment }else{ Buy-Now Payment } */
		$temp['new']['status'] = '-2';
		try{
			/* print_r($temp['new']);die; */
			$collection = $this->reviseCollection->create()->addFieldToFilter('transaction_id',['eq'=>$temp['new']['id']]);
			unset($temp['original']['id']);
			unset($temp['new']['id']);
			if(count($collection)==2){
				foreach($collection as $request){
					if($request->getType()=='original'){
						$request->addData($temp['original'])->setId($request->getId())->save();
					}
					if($request->getType()=='new'){
						$revise = $request->addData($temp['new'])->setId($request->getId())->save();
					}
				}
			}else{
				$reviseModelbkp = $this->revise->create()->setData($temp['original'])->save();
				$revise = $reviseModel = $this->revise->create()->setData($temp['new'])->save();
			}
			
			if($this->helper->revisePlan($revise)){

				$reportModel->setStatus(-2)->save();
				$this->messageManager->addSuccessMessage(
					__("Request was saved and email sent to %1 for order#%2",$revise->getEmail(),$revise->getOrderId())
				);
			}else{
				$this->messageManager->addErrorMessage(
					__("Failed to modify Plan")
				);
			}
		}catch(\Exception $e){
			$this->messageManager->addErrorMessage(
				__($e->getMessage())
			);
		
		}
		
	return	$this->_redirect('*/*/details',['_secure' => true,'id'=>$rowId]);
       
       
    }
}