<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Controller\Standard;

class Cancel extends \Magento\Framework\App\Action\Action
{
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultPageFactory;
    /**
     * @var \Magento\Customer\Model\Session
     */
    protected $_custmerSesion;
    /**
     * @var
     */
    protected $_resultForwardFactory;
    /**
     * @var \Magento\Framework\App\Config\ScopeConfigInterface
     */
    protected $_scopeConfig;

    /**
     * Index constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Customer\Model\Session $session
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     */
    public function __construct(
    	\Magento\Framework\App\Action\Context $context,
    	\Magento\Checkout\Model\Session $session,
    	\Magento\Sales\Model\Order $orderData,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory
    ) {
        $this->resultPageFactory = $resultPageFactory;
        $this->checkoutSesion = $session;
        $this->order = $orderData;
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|\Magento\Framework\View\Result\Page|void
     */
    public function execute()
    {
        $this->checkoutSesion->setQuoteId($this->checkoutSesion->getLayBuyStandardQuoteId(true));
        if ($this->checkoutSesion->getLastRealOrderId()) {
            $order = $this->order->loadByIncrementId($this->checkoutSesion->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
            }
        }
		$this->messageManager->addError($this->getRequest()->getParam('ErrorMessage','Try Again Later.'));
		$this->_redirect('checkout/onepage/failure',['_secure' => true]);
		return;
     
    }
}