<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Cron;

use Magento\Framework\App\Config\Storage\WriterInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
class CheckCron
{
    
    public $logger;

   /**
    * 
    * @param \Magento\Sales\Model\Order\Invoice $invoice
    */
    public function __construct(
        WriterInterface $configWriter,
         \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->configWriter = $configWriter;
        $this->scopeConfig = $scopeConfig;
    }

    public function execute()
    {

		if(!$this->scopeConfig->getValue('payment/laybuy/cronenabled')) {
			try {
				$this->configWriter->save("payment/laybuy/cronenabled", 1,$scope = ScopeConfigInterface::SCOPE_TYPE_DEFAULT, $scopeId = 0);
			} catch (\Exception $e) {
			    }
		}
    }
}