<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace Ced\LayBuy\Model\Config;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\Escaper;
use Magento\Payment\Helper\Data as PaymentHelper;

class LaybuyConfigProvider implements ConfigProviderInterface
{
    /**
     * @var string[]
     */
    protected $methodCode = 'laybuy';

    /**
     * @var Checkmo
     */
    protected $method;

    /**
     * @var Escaper
     */
    protected $escaper;

    /**
     * @param PaymentHelper $paymentHelper
     * @param Escaper $escaper
     */
    public function __construct(
        \Magento\Framework\View\LayoutInterface $layout,
        PaymentHelper $paymentHelper,
        Escaper $escaper
    ) {
        $this->layout = $layout;
        $this->escaper = $escaper;
        $this->method = $paymentHelper->getMethodInstance($this->methodCode);
    }

    /**
     * {@inheritdoc}
     */
    public function getConfig()
    {
        return $this->method->isAvailable() ? [
            'payment' => [
                'laybuy' => [
                    'laybuyhtml' => $this->layout->createBlock('Ced\LayBuy\Block\Form\Laybuy')->toHtml()
                ],
            ],
        ] : [];
    }

    
}
