<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license      https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Model;

class Report extends \Magento\Framework\Model\AbstractModel
{
	
	CONST REPORTS_HOSTNAME = "https://lay-buys.com/report/";
	
	protected static $_eventList = [];
    /**
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource|null $resource
     * @param \Magento\Framework\Data\Collection\AbstractDb|null $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Store\Model\StoreRepository $storeRepository,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        array $data = []
    ) {
        parent::__construct($context, $registry, null, null, $data);
        $this->storeRepository = $storeRepository;
        $this->scopeConfig = $scopeConfig;
        
    }

    /**
     *
     */
    public function _construct()
    {
        $this->_init('Ced\LayBuy\Model\ResourceModel\Report');
    }
    
    public function isFetchRequire() {
		if($this->getId() && $this->getStatus() == 0) {
			$nextPaymentDate = $this->getFirstPaymentDue();
			if($this->getTransaction() > 2) {
				$nextPaymentDate = date("Y-m-d h:i:s", strtotime($this->getFirstPaymentDue() . " +".($this->getTransaction() - 2)." month"));
			}
			if(time() >= strtotime($nextPaymentDate)) {
				return true;
			}
		}
		return false;
	}

    /**
     * Goes to specified host/path and fetches reports from there.
     * Save reports to database.
     *
     * @param array $config Api credentials
     * @return int Number of report rows that were fetched and saved successfully
     */
    public function fetchAndSave($config)
    {
        $fetched = 0;
        $this->laybuyhelper = \Magento\Framework\App\ObjectManager::getInstance()->get(\Ced\LayBuy\Helper\Data::class);
		$helper = $this->laybuyhelper;	
		
		$listing = $helper->fetchFromLaybuy($config);
		
		if(isset($listing->ACK))
		return false;
		

		foreach($listing as $orderId=>$reports){
		    
			$startIndex = 2;
			$status = $reports->status;
			$report = $reports->report;
			/* print_r($status);
			echo "<br/><br/><br/><br/>";
			print_r($report);die; */
			$model = array();
			$model = $this->loadByLayBuyRefId($orderId);
			$orderId = $model->getOrderId();
			$profileId = $model->getData('paypal_profile_id');
			/* echo $orderId;die; */
			$newStr = '<div class="grid"><div class="hor-scroll"><table cellspacing=0 class="data"><thead><tr class="headings"><th colspan=2 class=" no-link" style="text-align: center;"><span class="nobr">Instalment</span></th><th class=" no-link" style="text-align: center;"><span class="nobr">Date</span></th><th class=" no-link" style="text-align: center;"><span class="nobr">PayPal Transaction ID</span></th><th class=" no-link" style="text-align: center;"><span class="nobr">Status</span></th></tr></thead>';
			$newStr .= '<colgroup>
							<col width="100">
							<col width="75">
							<col width="183">
							<col width="183">
							<col width="98">
						</colgroup>';	
			$months = (int)$model->getData('months');
			$report_log = print_r($report,true);
			$pending_flag = false;
			$nextPaymentStatus = 'Pending';
			foreach($report as $month=>$transaction){
				$transaction->paymentDate = date('Y-m-d h:i:s', strtotime(str_replace('/','-',$transaction->paymentDate)));
				$date = $this->laybuyhelper->formatDate($transaction->paymentDate, \IntlDateFormatter::MEDIUM, true);
				$nextPaymentDate = $transaction->paymentDate;
				
				if($transaction->type == 'd'){
					$newStr .= '<tbody><tr class="even" ><td style="text-align: center;"> DP: </td><td style="text-align: center;"> '.$helper->getLocaleCurrency()
								   ->getCurrency($model->getData('currency'))
								   ->toCurrency($transaction->amount).' </td>'.
					  '<td style="text-align: center;"> '.$date.' </td>'.
					  '<td style="text-align: center;"> '.$transaction->txnID.' </td>'.
					  '<td style="text-align: center;"> '.$transaction->paymentStatus.' </td></tr>';
					continue;
				}elseif($transaction->type == 'p'){
					if(strlen($transaction->txnID)>0) {
						$startIndex++;
					}
					$pending_flag = true;
					$newStr .= '<tr ';
					if($month%2==0)
						$newStr .= 'class="even"';
					$newStr .= '>';
					$newStr .= '<td style="text-align: center;"> Month '.$month.': </td><td style="text-align: center;"> '.$helper->getLocaleCurrency()
								   ->getCurrency($model->getData('currency'))
									   ->toCurrency($transaction->amount).' </td>';
									   
					
					$newStr .= '<td style="text-align: center;"> '.$date.' </td>';

					$txnID = $transaction->txnID;
					
					$newStr .= '<td style="text-align: center;"> '.$txnID.' </td>';
						
					$newStr .= 	'<td style="text-align: center;"> '.$transaction->paymentStatus.' </td></tr>';
					
					
				}
				
				
			}
			
			//if($pending_flag)
				//$startIndex = $month+1;
			// else
				// $startIndex = $month+2;
			if($month<$months){
				for($month=$month+1;$month<=$months;$month++){
					$newStr .= '<tr ';
					if($month%2==0)
						$newStr .= 'class="even"';
					$newStr .= '>';
					$newStr .= '<td style="text-align: center;"> Month '.$month.': </td><td style="text-align: center;"> '.$helper->getLocaleCurrency()
								   ->getCurrency($model->getData('currency'))
									   ->toCurrency($model->getData('payment_amounts')).' </td>';
									   
					$nextPaymentDate = date("Y-m-d h:i:s", strtotime($nextPaymentDate . " +1 month"));
					$date = $helper->formatDate($nextPaymentDate, \IntlDateFormatter::MEDIUM, true);
					$newStr .= '<td style="text-align: center;"> '.$date.' </td>';
					$newStr .= '<td style="text-align: center;">&nbsp;</td>';
					$newStr .= 	'<td style="text-align: center;"> '.$nextPaymentStatus.' </td></tr>';
				}
			}
			$newStr .= '</tbody></table></div></div>';
			
			switch($status){
				case -1: if($helper->processOrder($orderId,0)){
							$model->setStatus(-1)->setReport($newStr)->setTransaction($startIndex)->save();	/* Cancel */
							$fetched++;
						}
						break;
				case 0: if($helper->processOrder($orderId,2,$report,$profileId)){
							$st = 0;
							if($model->getStatus() == -2) {
								$st = -2;
							}
							$model->setStatus($st)->setReport($newStr)->setTransaction($startIndex)->save(); /* Processing */
							$fetched++;
						}
						break;
				case 1: if($helper->processOrder($orderId,1)){
							$model->setStatus(1)->setReport($newStr)->setTransaction($startIndex)->save();	/* Paid*/
							$fetched++;
						}
						break;  
			}
			
		}
        
        return $fetched;
    }

    /**
     * Return name for row column
     *
     * @param string $field Field name in row model
     * @return string
     */
    public function getFieldLabel($field)
    {
        switch ($field) {
            case 'report_date':
                return __('Report Date');
            case 'account_id':
                return __('Merchant Account');
            case 'transaction_id':
                return __('Transaction ID');
            case 'order_id':
                return __('Order ID');
			case 'mid':
                return __('Lay-Buy Member ID');
            case 'paypal_profile_id':
                return __('PayPal Profile ID');
            case 'laybuy_ref_no':
                return __('Lay-Buy Reference ID');
			 case 'status':
                return __('Status');
            case 'amount':
                return __('Amount');
			case 'total_amount':
                return __('Total Amount :');
            case 'downpayment':
                return __('Down Payment %');
            case 'months':
                return __('Months');
			case 'months_to_pay':
                return __('Months to Pay : ');		
            case 'downpayment_amount':
                return __('Down Payment Amount');
			case 'dp_amount':
                return __('Initial Payment : ');
            case 'payment_amounts':
                return __('Payment Amounts');
            case 'first_payment_due':
                return __('First Payment Due');
			case 'last_payment_due':
                return __('Last Payment Due');
			case 'report':
                return __('Payment Record');
            case 'firstname':
                return __('First Name');
            case 'lastname':
                return __('Last Name');
			case 'email':
                return __('Email');
            case 'address':
                return __('Address');
			case 'suburb':
                return __('Suburb');
            case 'state':
                return __('State');
			case 'country':
                return __('Country');
            case 'postcode':
                return __('Postcode');
            case 'custom_field':
                return __('Custom');
			case 'preview':
                return __('Preview');
            default:
                return __('%1',$field);
        }
    }

    /**
     * Iterate through website configurations and collect all SFTP configurations
     * Filter config values if necessary
     *
     * @param bool $automaticMode Whether to skip settings with disabled Automatic Fetching or not
     * @return array
     */
    public function getApiCredentials($automaticMode = false)
    {
        $configs = [];
        $uniques = [];
        foreach($this->storeRepository->getList() as $store) {
            /*@var $store Mage_Core_Model_Store */
            $active = (bool)$store->getConfig('laybuy/fetch_reports/active');
            if (!$active && $automaticMode) {
                continue;
            }
            $cfg = array(
                'hostname'  	=> $store->getConfig('laybuy/fetch_reports/ftp_ip'),
                'username' => $store->getConfig('payment/laybuy/membership_number'),
            );
            if (empty($cfg['username'])) {
                continue;
            }
            if (empty($cfg['hostname'])) {
                $cfg['hostname'] = self::REPORTS_HOSTNAME;
            }
            // avoid duplicates
            if (in_array(serialize($cfg), $uniques)) {
                continue;
            }
            $uniques[] = serialize($cfg);
            $configs[] = $cfg;
        }
        return $configs;
    }
	
	/**
     * Load report by Order Id
     *
     */
    public function loadByOrderId($orderId)
    {
        $this->getResource()->loadByOrderId($this, $orderId);
        return $this;
    }
	
	/**
     * Load report by Lay-Buy Reference Id
     *
     */
    public function loadByLayBuyRefId($laybuyId){
		$this->getResource()->loadByLayBuyRefId($this, $laybuyId);
        return $this;
	}

    /**
     * Fill/translate and sort all event codes/labels
     */
    protected function _generateEventLabels()
    {
        if (!self::$_eventList) {
            self::$_eventList = array(
            'T0000' => __('General: received payment of a type not belonging to the other T00xx categories'),
            'T0001' => __('Mass Pay Payment'),
            'T0002' => __('Subscription Payment, either payment sent or payment received'),
            'T0003' => __('Preapproved Payment (BillUser API), either sent or received'),
            'T0004' => __('eBay Auction Payment'),
            'T0005' => __('Direct Payment API'),
            'T0006' => __('Express Checkout APIs'),
            'T0007' => __('Website Payments Standard Payment'),
            'T0008' => __('Postage Payment to either USPS or UPS'),
            'T0009' => __('Gift Certificate Payment: purchase of Gift Certificate'),
            'T0010' => __('Auction Payment other than through eBay'),
            'T0011' => __('Mobile Payment (made via a mobile phone)'),
            'T0012' => __('Virtual Terminal Payment'),
            'T0100' => __('General: non-payment fee of a type not belonging to the other T01xx categories'),
            'T0101' => __('Fee: Web Site Payments Pro Account Monthly'),
            'T0102' => __('Fee: Foreign ACH Withdrawal'),
            'T0103' => __('Fee: WorldLink Check Withdrawal'),
            'T0104' => __('Fee: Mass Pay Request'),
            'T0200' => __('General Currency Conversion'),
            'T0201' => __('User-initiated Currency Conversion'),
            'T0202' => __('Currency Conversion required to cover negative balance'),
            'T0300' => __('General Funding of LayBuy Account '),
            'T0301' => __('LayBuy Balance Manager function of LayBuy account'),
            'T0302' => __('ACH Funding for Funds Recovery from Account Balance'),
            'T0303' => __('EFT Funding (German banking)'),
            'T0400' => __('General Withdrawal from LayBuy Account'),
            'T0401' => __('AutoSweep'),
            'T0500' => __('General: Use of LayBuy account for purchasing as well as receiving payments'),
            'T0501' => __('Virtual LayBuy Debit Card Transaction'),
            'T0502' => __('LayBuy Debit Card Withdrawal from ATM'),
            'T0503' => __('Hidden Virtual LayBuy Debit Card Transaction'),
            'T0504' => __('LayBuy Debit Card Cash Advance'),
            'T0600' => __('General: Withdrawal from LayBuy Account'),
            'T0700' => __('General (Purchase with a credit card)'),
            'T0701' => __('Negative Balance'),
            'T0800' => __('General: bonus of a type not belonging to the other T08xx categories'),
            'T0801' => __('Debit Card Cash Back'),
            'T0802' => __('Merchant Referral Bonus'),
            'T0803' => __('Balance Manager Account Bonus'),
            'T0804' => __('LayBuy Buyer Warranty Bonus'),
            'T0805' => __('LayBuy Protection Bonus'),
            'T0806' => __('Bonus for first ACH Use'),
            'T0900' => __('General Redemption'),
            'T0901' => __('Gift Certificate Redemption'),
            'T0902' => __('Points Incentive Redemption'),
            'T0903' => __('Coupon Redemption'),
            'T0904' => __('Reward Voucher Redemption'),
            'T1000' => __('General. Product no longer supported'),
            'T1100' => __('General: reversal of a type not belonging to the other T11xx categories'),
            'T1101' => __('ACH Withdrawal'),
            'T1102' => __('Debit Card Transaction'),
            'T1103' => __('Reversal of Points Usage'),
            'T1104' => __('ACH Deposit (Reversal)'),
            'T1105' => __('Reversal of General Account Hold'),
            'T1106' => __('Account-to-Account Payment, initiated by LayBuy'),
            'T1107' => __('Payment Refund initiated by merchant'),
            'T1108' => __('Fee Reversal'),
            'T1110' => __('Hold for Dispute Investigation'),
            'T1111' => __('Reversal of hold for Dispute Investigation'),
            'T1200' => __('General: adjustment of a type not belonging to the other T12xx categories'),
            'T1201' => __('Chargeback'),
            'T1202' => __('Reversal'),
            'T1203' => __('Charge-off'),
            'T1204' => __('Incentive'),
            'T1205' => __('Reimbursement of Chargeback'),
            'T1300' => __('General (Authorization)'),
            'T1301' => __('Reauthorization'),
            'T1302' => __('Void'),
            'T1400' => __('General (Dividend)'),
            'T1500' => __('General: temporary hold of a type not belonging to the other T15xx categories'),
            'T1501' => __('Open Authorization'),
            'T1502' => __('ACH Deposit (Hold for Dispute or Other Investigation)'),
            'T1503' => __('Available Balance'),
            'T1600' => __('Funding'),
            'T1700' => __('General: Withdrawal to Non-Bank Entity'),
            'T1701' => __('WorldLink Withdrawal'),
            'T1800' => __('Buyer Credit Payment'),
            'T1900' => __('General Adjustment without businessrelated event'),
            'T2000' => __('General (Funds Transfer from LayBuy Account to Another)'),
            'T2001' => __('Settlement Consolidation'),
            'T9900' => __('General: event not yet categorized'),
            );
            asort(self::$_eventList);
        }
    }
	
	public function getArray($type,$value,$storeId){
		$options = array();
		if($type=='dp_amount'){
			$mind = (int)$this->scopeConfig->getValue('payment/laybuy/mind',\Magento\Store\Model\ScopeInterface::SCOPE_STORE,$storeId);
			if(!$mind || $mind<20 || $mind>50){
				$mind = 20;
			}
			
			$mind = floor($mind / 10) * 10;
			$maxd = (int)$this->scopeConfig->getValue('payment/laybuy/maxd',\Magento\Store\Model\ScopeInterface::SCOPE_STORE,$storeId);
			if(!$maxd || $maxd<20 || $maxd>50){
				$maxd = 50;
			}
			$maxd = round($maxd / 10) * 10;
			$vrg = 1;
			for ($e=$mind; $e<=$maxd; $e+=10) {
			  $options[] = array('value'=>$e,'label'=>$e.'%');
			  $vrg=0;
			}
		}
		if($type=='months'){
			$mmm = $this->scopeConfig->getValue('payment/laybuy/months',\Magento\Store\Model\ScopeInterface::SCOPE_STORE,$storeId);
			if (!strlen($mmm)) $mmm = 3;
			if ($mmm < 1) $mmm = 1;
			if ($mmm > 6) $mmm = 6;
			for ($e=1; $e<=$mmm; $e++) {
			  $options[] = array('value'=>$e,'label'=>$e .' month'.($e > 1 ? 's' :''));
			}
		}
		return $options;
	}

}