<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Model\ResourceModel;

class Report extends \Magento\Framework\Model\ResourceModel\Db\AbstractDb
{
    /**
     *
     */
   public function _construct()
   {
        $this->_init('laybuy_transaction_report', 'id');
    }
    
    public function loadByOrderId(\Ced\LayBuy\Model\Report $report, $order_id)

    {

        $adapter = $this->getConnection();

        $select  = $adapter->select()

            ->from($this->getMainTable())

            ->where("order_id = :order_id AND status!='-2' AND status!='2'");



        $data = $adapter->fetchRow($select, [':order_id' => $order_id]);

        if ($data) {

            $report->addData($data);

        }



        return $this;

    }
    public function loadByLayBuyRefId(\Ced\LayBuy\Model\Report $report, $laybuy_ref_no)

    {

        $adapter = $this->getConnection();

        $select  = $adapter->select()

            ->from($this->getMainTable())

            ->where('laybuy_ref_no = :laybuy_ref_no');



        $data = $adapter->fetchRow($select, [':laybuy_ref_no' => $laybuy_ref_no]);

        if ($data) {

            $report->addData($data);

        }



        return $this;

    }
}