<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Model\System\Config\Source;


class Categories
{
    /**
     * @var \Magento\Catalog\Model\CategoryFactory
     */
    protected $_categoryFactory;

    /**
     * @var
     */
    private $options;

    /**
     * CategoryCollection constructor.
     * @param \Magento\Catalog\Model\CategoryFactory $categoryFactory
     */
    public function __construct(
        \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory $categoryCollectionFactory
    ) {
        $this->categoryCollection = $categoryCollectionFactory;
    }

    /**
     * Retrieve Option values array
     *
     * @return array
     */
    public function toOptionArray()
    {
        $options = [];
        $collection = $this->categoryCollection->create()
            ->addAttributeToSelect(['name', 'is_active', 'parent_id', 'level', 'children'])
            ->addAttributeToFilter('entity_id', ['neq' => \Magento\Catalog\Model\Category::TREE_ROOT_ID])
            ->load();

        foreach ($collection as $category) {
            $options []= [
               'label' => $category->getName()!=''?$category->getName():'Default Category',
               'value' => $category->getId()
            ];
        }
        return $options;
    }
}
