<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Observer;


use Magento\Framework\Event\ObserverInterface;


Class OrderCancel implements ObserverInterface
{
   
    public function __construct(
        \Ced\LayBuy\Model\Report $laybuyReport,
        \Ced\LayBuy\Helper\Data $laybuyHelper,
        \Magento\Framework\App\Request\Http $request
    ) {
        $this->laybuyReport = $laybuyReport;
        $this->laybuyHelper = $laybuyHelper;
        $this->request=$request;
    }
    /**
     * Cancel the asscociated vendor order
     * @param \Magento\Framework\Event\Observer $observer
     * @return $this
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        
        $order = $observer->getEvent()->getOrder();
		try{
			$model = $this->laybuyReport->loadByOrderId($order->getIncrementId());
			if($model && $model->getId() && $this->request->getModuleName()!='laybuy'){
				$newStrReport = preg_replace('/Pending/i', 'Canceled', $model->getReport());

				if($this->laybuyHelper->cancelPaypalProfile($model->getPaypalProfileId(),$model->getStoreId())){
						$model->setReport($newStrReport);
						$model->setStatus(-1);
						$model->save();
				}
			
			}
		}catch(\Exception $e){
		
		}
    }
}