<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */

namespace Ced\LayBuy\Observer;


use Magento\Framework\Event\ObserverInterface;


Class PaymentInfo implements ObserverInterface
{
   

    /**
     * Cancel the asscociated vendor order
     * @param \Magento\Framework\Event\Observer $observer
     * @return $this
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        
        $transaction = $observer->getEvent()->getTransaction();
        $transport = $observer->getEvent()->getTransport();
		
		if($transaction && count($transaction)){
			foreach($transaction as $txn){
				$transport->setData($txn->getFieldLabel('Instalment Plan')."-".$txn->getId(),$txn->getReport());
			}
		}
		
        return $this;
    }
}