<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Setup;
 
use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
 
/**
 * @codeCoverageIgnore
 */
class InstallSchema implements InstallSchemaInterface
{
    /**
     * {@inheritdoc}
     *
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     */
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        /**
         *
         */
    	$installer = $setup;
        /**
         *
         */
    	$installer->startSetup();
    	 
    	
    	$table = $installer->getConnection()->newTable(
    			$installer->getTable('laybuy_transaction_report')
    	)
    	->addColumn(
    			'id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			null,
    			['identity' => true, 'unsigned' => true, 'nullable' => false, 'primary' => true],
    			'Id'
    	)->addColumn(
    			'order_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'Order Id'
    	)->addColumn(
    			'firstname',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'First Name'
    	)->addColumn(
    		   'lastname',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'First Name'
    	)->addColumn(
    			'address',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'suburb',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Customer Email'
    	)->addColumn(
    			'state',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'country',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'postcode',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'First Name'
    	)->addColumn(
    			'email',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'amount',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
            'Amount'
    	)->addColumn(
    			'currency',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			5,
    			[],
    			'First Name'
    	)->addColumn(
    			'downpayment',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'months',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'First Name'
    	)->addColumn(
    			'downpayment_amount',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'payment_amounts',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'first_payment_due',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'First Name'
    	)->addColumn(
    			'last_payment_due',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'First Name'
    	)->addColumn(
    			'store_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			null,
    			['unsigned' => true, 'nullable' => false],
    			'Store Id'
    	)->addColumn(
    			'created_at',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'Created At'
    	)->addColumn(
    			'status',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			['unsigned' => true, 'nullable' => false],
    			'Status'
    	)->addColumn(
    			'report',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Report'
    	)->addColumn(
    			'transaction',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'Transaction'
    	)->addColumn(
    			'paypal_profile_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Paypal Profile Id'
    	)->addColumn(
    			'laybuy_ref_no',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Laybuy Ref No'
    	)
    	->setComment(
    			'Laybuy Transaction Report'
    	);
    	$installer->getConnection()->createTable($table);
    	

    	
    	$table2 = $installer->getConnection()->newTable(
    			$installer->getTable('laybuy_revise_request_report')
    	)
    	->addColumn(
    			'id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			null,
    			['identity' => true, 'unsigned' => true, 'nullable' => false, 'primary' => true],
    			'Id'
    	)->addColumn(
    			'type',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Type'
    	)->addColumn(
    			'transaction_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'Transaction Id'
    	)->addColumn(
    			'order_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'Order Id'
    	)->addColumn(
    			'firtname',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'First Name'
    	)->addColumn(
    		   'lastname',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			255,
    			[],
    			'First Name'
    	)->addColumn(
    			'address',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'suburb',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Customer Email'
    	)->addColumn(
    			'state',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'country',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'postcode',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'First Name'
    	)->addColumn(
    			'email',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'First Name'
    	)->addColumn(
    			'amount',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
            'Amount'
    	)->addColumn(
    			'currency',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			5,
    			[],
    			'First Name'
    	)->addColumn(
    			'downpayment',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'months',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'First Name'
    	)->addColumn(
    			'downpayment_amount',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'payment_amounts',
    			\Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
    			'12,4',
                [],
    			'First Name'
    	)->addColumn(
    			'first_payment_due',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'First Name'
    	)->addColumn(
    			'last_payment_due',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'First Name'
    	)->addColumn(
    			'store_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			null,
    			['unsigned' => true, 'nullable' => false],
    			'Store Id'
    	)->addColumn(
    			'created_at',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
                null,
                ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
    			'Created At'
    	)->addColumn(
    			'status',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			['unsigned' => true, 'nullable' => false],
    			'Status'
    	)->addColumn(
    			'report',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Report'
    	)->addColumn(
    			'transaction',
    			\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
    			11,
    			['unsigned' => true, 'nullable' => false],
    			'Transaction'
    	)->addColumn(
    			'paypal_profile_id',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Paypal Profile Id'
    	)->addColumn(
    			'laybuy_ref_no',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Laybuy Ref No'
    	)->addColumn(
    			'payment_type',
    			\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
    			null,
    			[],
    			'Payment Type'
    	)
    	->setComment(
    			'Laybuy Revise Report'
    	);
    	$installer->getConnection()->createTable($table2);
    
    	

	    $installer->endSetup();
    }
}