<?php
/**
 * CedCommerce
  *
  * NOTICE OF LICENSE
  *
  * This source file is subject to the End User License Agreement (EULA)
  * that is bundled with this package in the file LICENSE.txt.
  * It is also available through the world-wide-web at this URL:
  * http://cedcommerce.com/license-agreement.txt
  *
  * @category  Ced
  * @package   Ced_LayBuy
  * @author    CedCommerce Core Team <connect@cedcommerce.com >
  * @copyright Copyright CEDCOMMERCE (http://cedcommerce.com/)
  * @license   https://cedcommerce.com/license-agreement.txt
  */
namespace Ced\LayBuy\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * @codeCoverageIgnore
 */
class UpgradeSchema implements UpgradeSchemaInterface
{
    

    /**
     * {@inheritdoc}
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $tableName = $installer->getTable('quote_payment');
			if ($installer->getConnection()->isTableExists($tableName) == true) {
				$installer->getConnection()->addColumn(
						$tableName,
						'laybuy_init',
						[
						'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
						'length' => null,
						'nullable' => false,
						'comment' => 'LayBuy Int'
						]
				);
				$installer->getConnection()->addColumn(
						$tableName,
						'laybuy_months',
						[
						'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
						'length' => null,
						'nullable' => false,
						'comment' => 'LayBuy Months'
						]
				);

			}
			
			$tableName = $installer->getTable('sales_order_payment');
			if ($installer->getConnection()->isTableExists($tableName) == true) {
				$installer->getConnection()->addColumn(
						$tableName,
						'laybuy_init',
						[
						'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
						'length' => null,
						'nullable' => false,
						'comment' => 'LayBuy Int'
						]
				);
				$installer->getConnection()->addColumn(
						$tableName,
						'laybuy_months',
						[
						'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
						'length' => null,
						'nullable' => false,
						'comment' => 'LayBuy Months'
						]
				);

			}
    }

    
}
